<?php

	include_once( realpath( dirname( __FILE__ ) ) . "/../../../classes/PluginsTransports.class.php" );
	
	include_once( realpath( dirname( __FILE__ ) ) . "/../../../classes/Message.class.php" );
	include_once( realpath( dirname( __FILE__ ) ) . "/../../../classes/Messagedesc.class.php" );
	include_once( realpath( dirname( __FILE__ ) ) . "/../../../classes/Variable.class.php" );
	include_once( realpath( dirname( __FILE__ ) ) . "/Tarifcolissimoaccess.class.php" );
	
	class ColissimoAccess extends PluginsTransports {
	
		public function __construct() {
		
			parent::__construct( "colissimoaccess" );
		}
		
		public function init() {
		
			$this->ajout_desc(
				"Colissimo sans signature",
				"Livraison par Colissimo National sans signature",
				"",
				1
			);
			
			//	Création de la table tarifcolissimoacces
			$cnx = new Cnx();
			$sql = "
				CREATE TABLE 
					`tarifcolissimoaccess` 
				(
					`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,
					`poidsmax` FLOAT NOT NULL ,
					`tarif` FLOAT NOT NULL
				)
			";
			$resultat = mysql_query( $sql , $cnx->link );
			
			//	Ajout d'une ligne dans la table variable
			$variable = new Variable();
			if ( !$variable->charger( 'colissimoaccess_tarifmax' ) ) {
			
				$objVariableTarifMax = new Variable();
				
				$variable->nom = 'colissimoaccess_tarifmax';
				$variable->valeur = 0;
				$variable->protege = 0;
				$variable->cache = 0;
				$variable->add();
			}
			
			//	Message de livraison
			$messageExiste = new Message();
			if ( !$messageExiste->charger( "colissimoaccess" ) ) {
			
				$message = new Message();
				$message->nom = "colissimoaccess";
				$lastid = $message->add();
				
				$messagedesc = new Messagedesc();
				$messagedesc->message = $lastid;
				$messagedesc->lang = 1;
				$messagedesc->titre = "Colissimo sans signature";
				$messagedesc->description = "__RAISON__ __NOM__ __PRENOM__,\n\nNous vous remercions de votre commande sur notre site __URLSITE__\n\nUn colis concernant votre commande __COMMANDE__ du __DATE__ __HEURE__ a quitté nos entrepôts pour être pris en charge par La Poste le __DATEDJ__.\n\nSon numéro de suivi est le suivant : __COLIS__\nIl vous permet de suivre votre colis en ligne sur le site de La Poste : www.coliposte.net\nIl vous sera, par ailleurs, très utile si vous étiez absent au moment de la livraison de votre colis : en fournissant ce numéro de Colissimo Suivi, vous pourrez retirer votre colis dans le bureau de Poste le plus proche.\n\nATTENTION ! Si vous ne trouvez pas l'avis de passage normalement déposé dans votre boîte aux lettres au bout de 48 Heures jours ouvrables, n'hésitez pas à aller le réclamer à votre bureau de Poste, muni de votre numéro de Colissimo Suivi.\n\nNous restons à votre disposition pour toute information complémentaire.\nCordialement";
				$messagedesc->add();
			}
		}
		
		public function calcule() {
		
			$listeTarifs = $this->getTarifs();
			
			foreach ( $listeTarifs as $ligneTarif ) {
			
				if ( $this->poids <= $ligneTarif->poidsmax ) {
				
					return $ligneTarif->tarif;
				}
			}
			
			return $this->getTarifMax();
		}
		
		function statut( $commande ) {
			
			if ( $commande->statut == "4" ) {
				
				if ( !$commande->colis ) {
				
					return;
				}
				
				$modTransport = new Modules();
				$modTransport->charger( 'colissimoaccess' );
				
				if ( $modTransport->id != $commande->transport ) {
				
					return;
				}
				
				$message = new Message();
				$message->charger( "colissimoaccess" );

				$messagedesc = new Messagedesc();
				$messagedesc->charger( $message->id );

				$client = new Client();
				$client->charger_id( $commande->client );
				
				$tabRaisons = array(
					"1" => "Madame" ,
					"2" => "Mademoiselle" ,
					"3" => "Monsieur"
				);
				if ( isset( $tabRaisons[$client->raison] ) ) {
				
					$raison = $tabRaisons[$client->raison];
				}
				
				$urlsite = new Variable();
				$urlsite->charger("urlsite");

				$emailcontact = new Variable();
				$emailcontact->charger("emailcontact");

          		$jour = substr($commande->date, 8, 2);
		        $mois = substr($commande->date, 5, 2);
		        $annee = substr($commande->date, 0, 4);
                $heure = substr($commande->date, 11, 2);
                $minute = substr($commande->date, 14, 2);
                $seconde = substr($commande->date, 17, 2);

				$messagedesc->description = str_replace("__RAISON__", "$raison", $messagedesc->description);
				$messagedesc->description = str_replace("__NOM__", $client->nom, $messagedesc->description);
				$messagedesc->description = str_replace("__PRENOM__", $client->prenom, $messagedesc->description);
				$messagedesc->description = str_replace("__URLSITE__", $urlsite->valeur, $messagedesc->description);
				$messagedesc->description = str_replace("__COMMANDE__", $commande->ref, $messagedesc->description);
				$messagedesc->description = str_replace("__DATE__", $jour . "/" . $mois . "/" . $annee, $messagedesc->description);
				$messagedesc->description = str_replace("__HEURE__", $heure . ":" . $minute . ":" . $seconde, $messagedesc->description);
				$messagedesc->description = str_replace("__DATEDJ__", date("d") . "/" . date("m") . "/" . date("Y"), $messagedesc->description);
				$messagedesc->description = str_replace("__COLIS__", $commande->colis, $messagedesc->description);
				mail($client->email, $messagedesc->titre, $messagedesc->description, "From: " . $emailcontact->valeur);
			}
		}
		
		public function getTarifs() {
			
			$listeTarifs = array();
			
			$sql = "
				SELECT
					*
				FROM
					tarifcolissimoaccess
				ORDER BY
					poidsmax
			";
			
			$cnx = new Cnx();
			$resultat = mysql_query( $sql , $cnx->link );
			
			while ( $ligneTarif = mysql_fetch_object( $resultat ) ) {
				
				$listeTarifs[] = $ligneTarif;
			}
			
			return $listeTarifs;
		}
		
		public function getTarifMax() {
		
			$objVariable = new Variable( 'colissimoaccess_tarifmax' );
			
			$valeur = $objVariable->valeur;
			if ( !$valeur ) {
			
				$valeur = 0;
			}
			
			return $valeur;
		}
		
		public function majTarifMax( $nouveauTarifMax ) {
		
			$objVariable = new Variable( 'colissimoaccess_tarifmax' );
			
			$objVariable->valeur = $nouveauTarifMax;
			$objVariable->maj();
		}
	}
